import { BaseBatchUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-batch-update-status.manager';
import { TermConditionEntity } from '../../entities/term-condition.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { TermConditionModel } from '../../../data/models/term-condition.model';
import { TermConditionChangeStatusEvent } from '../../entities/event/term-condition-change-status.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchConfirmTermConditionManager extends BaseBatchUpdateStatusManager<TermConditionEntity> {
  validateData(data: TermConditionEntity): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return TermConditionModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: TermConditionChangeStatusEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
